

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable allchans 0

    variable Rmsg ""
    variable Wmsg ""

    variable ModuleName v1724
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable DPPEnable 1

   source [file join V1724 Registers.tcl]
 

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc do_RegisterHelp {W} {
      variable [set W]Register

        set Txtfile [file join V1724 [set [set W]Register].txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }


#    register access procedures

   proc ReadRegister {RegName} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable Rmsg

       set r $ModuleName#$ModuleIndex
       set z [catch {::namespace inscope ::urn:VMEAccessServer ReadRegister $r.$RegName} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# puts "ReadRegister $r.$RegName returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegister $r.$RegName returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc 0
       }
       return $rc
   }

   proc WriteRegister {RegName RegData} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable allmodules
       variable Wmsg

       if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}

       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $r.$RegName $RegData} Wmsg]

       if {$z == 0} {
# puts "WriteRegister $r.$RegName $RegData [format 0x%x $RegData]"
#           InsertLog "WriteRegister $r.$RegName $RegData [format 0x%x $RegData] returned: [lindex $Wmsg 5]"
       } else {
           InsertLog "WriteRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc WriteBitRegister {RegName Bit RegData} {

        set Mask [expr 1 << $Bit]

        if {$RegData == 0} {WriteRegister $RegName [expr [ReadRegister $RegName] & ~$Mask]}
        if {$RegData == 1} {WriteRegister $RegName [expr [ReadRegister $RegName] | $Mask]}

   }

   proc show_variables {} {
        variable allchans

        variable allmodules
        variable LogFlag
        variable DebugFlag
        variable ShowLogFlag
        variable MRegister
        variable ChRegister
        variable DPPEnable
        variable Rmsg
        variable Wmsg

             InsertLog "DPPEnable=$DPPEnable"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; DebugFlag=$DebugFlag "
             InsertLog "allchans=$allchans; allmodules=$allmodules"
             InsertLog "MRegister=$MRegister; ChRegister=$ChRegister"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {

       do_UpdateModuleRegisters
       do_UpdateChannelRegisters
   }

    proc UpdateChannel {} {

       do_UpdateChannelRegisters
   }

   proc do_SelectModuleRegister {w} {
        variable MRegister
        variable MRegisterItem

        switch $w {
           "Channel Enable Mask"        {set MRegister ChEnable}
           "Trigger Source Enable Mask" {set MRegister TrigSrcEnable}
           "Front Panel Trigger Out Enable Mask" {set MRegister FPTrigEnable}
           "Analog Monitor"             {set MRegister AnalogMon}
           "Front Panel I/O Control"    {set MRegister FPIOCtrl}
           "Configuration"              {set MRegister CONFIGURATION}
           "Buffer Organisation"        {set MRegister BUFF_ORG}
           "Acquisition Window"         {set MRegister CUST_SIZE}

           default  {set MRegister $w}
        }

        set MRegisterItem "$w"
   }

   proc do_SelectChannelRegister {w} {
        variable ChRegister
        variable ChRegisterItem

        switch $w {
           "Post Trigger Window"        {set ChRegister ChPostTrig}

           default  {set ChRegister $w}
        }

        set ChRegisterItem "$w"
   }

    proc do_SetModuleRegister {w v} {
        variable DebugFlag
        variable $w

        if {$DebugFlag == 1} {InsertLog "$w = $v"}

        switch -glob $w {
            "Buffer Organisation" -
            BUFF_ORG        {WriteRegister BufferOrg $v}
            "Acquisition Window" -
            CUST_SIZE       {WriteRegister CustomSize $v}
            CHENABLE*       {WriteBitRegister ChEnable [string range $w 8 end] $v}
            TRIGSRCENABLE*  {WriteBitRegister TrigSrcEnable [string range $w 13 end] $v}
            FPTRIGENABLE*   {WriteBitRegister FPTrigOutEnable [string range $w 12 end] $v}
            ANALOGMON*      {WriteBitRegister AnalogMon [string range $w 9 end] $v}
            Reset -
            AcqControl -
            Clear -
            SoftTrig        {WriteRegister $w $v}
            CONFIGURATION.* {set $w $v; do_SetModuleConfig}
            FPIO*           {set $w $v; do_SetFPIO}

            default {set $w $v}
        }
   }

    proc do_UpdateModuleRegisters {} {

       variable BUFF_ORG; set BUFF_ORG [ReadRegister BufferOrg]
       variable CUST_SIZE; set CUST_SIZE [ReadRegister CustomSize]
       variable CHENABLE; set CHENABLE [ReadRegister ChEnable]
       variable TRIGSRCENABLE; set TRIGSRCENABLE [ReadRegister TrigSrcEnable]
       variable FPTRIGENABLE; set FPTRIGENABLE [ReadRegister FPTrigOutEnable]
       variable ANALOGMON; set ANALOGMON [ReadRegister AnalogMon]
       variable CONFIGURATION; set CONFIGURATION [ReadRegister ChConfig]; do_GetModuleConfig
       variable FPIO; set FPIO [ReadRegister FPIOControl]; do_GetFPIO
 
   }

   proc do_GetModuleConfig {} {
       variable CONFIGURATION
       variable CONFIGURATION.DualTrace
       variable CONFIGURATION.InvertInput
       variable CONFIGURATION.TrigMode
       variable CONFIGURATION.TrigOlap
       variable CONFIGURATION.TestMode
       variable CONFIGURATION.VProbe1
       variable CONFIGURATION.VProbe2
       variable CONFIGURATION.OscMode
       variable CONFIGURATION.EnergyMode
       variable CONFIGURATION.TimeTagMode
       variable CONFIGURATION.DigVProbe

       set CONFIGURATION.TrigOlap [expr ($CONFIGURATION >> 1) & 1]
       set CONFIGURATION.TestMode [expr ($CONFIGURATION >> 3) & 1]
       set CONFIGURATION.TrigMode [expr ($CONFIGURATION >> 8) & 1]
       set CONFIGURATION.InvertInput [expr ($CONFIGURATION >> 9) & 1]
       set CONFIGURATION.DualTrace [expr ($CONFIGURATION >> 11) & 1]
       set CONFIGURATION.VProbe1 [expr ($CONFIGURATION >> 12) & 3]
       set CONFIGURATION.VProbe2 [expr ($CONFIGURATION >> 14) & 3]
       set CONFIGURATION.OscMode [expr ($CONFIGURATION >> 16) & 1]
       set CONFIGURATION.EnergyMode [expr ($CONFIGURATION >> 17) & 1]
       set CONFIGURATION.TimeTagMode [expr ($CONFIGURATION >> 18) & 1]
       set CONFIGURATION.DigVProbe [expr ($CONFIGURATION >> 20) & 7]
   }

   proc do_SetModuleConfig {} {
       variable CONFIGURATION
       variable CONFIGURATION.DualTrace
       variable CONFIGURATION.InvertInput
       variable CONFIGURATION.TrigMode
       variable CONFIGURATION.TrigOlap
       variable CONFIGURATION.TestMode
       variable CONFIGURATION.VProbe1
       variable CONFIGURATION.VProbe2
       variable CONFIGURATION.OscMode
       variable CONFIGURATION.EnergyMode
       variable CONFIGURATION.TimeTagMode
       variable CONFIGURATION.DigVProbe

       set CONFIGURATION [expr ([set CONFIGURATION.TrigOlap] << 1) + \
                               ([set CONFIGURATION.TestMode] << 3) + \
                               (1 << 4) + \
                               ([set CONFIGURATION.TrigMode] << 8) + \
                               ([set CONFIGURATION.InvertInput] << 9) + \
                               ([set CONFIGURATION.DualTrace] << 11) + \
                               ([set CONFIGURATION.VProbe1] << 12) + \
                               ([set CONFIGURATION.VProbe2] << 14) + \
                               ([set CONFIGURATION.OscMode] << 16) + \
                               ([set CONFIGURATION.EnergyMode] << 17) + \
                               ([set CONFIGURATION.TimeTagMode] << 18) + \
                               ([set CONFIGURATION.DigVProbe] << 20)]

       WriteRegister ChConfig $CONFIGURATION

     variable TRIGSRCENABLE; WriteRegister TrigSrcEnable $TRIGSRCENABLE  ;# until firmware bug fixed
   }

   proc do_GetFPIO {} {
      variable FPIO 
      variable FPIO.B15 
      variable FPIO.B14 
      variable FPIO.B6 
      variable FPIO.B5 
      variable FPIO.B4 
      variable FPIO.B3 
      variable FPIO.B2 
      variable FPIO.B1 
      variable FPIO.B0

       set FPIO.B0 [expr $FPIO & 1]
       set FPIO.B1 [expr ($FPIO >> 1) & 1]
       set FPIO.B2 [expr ($FPIO >> 2) & 1]
       set FPIO.B3 [expr ($FPIO >> 3) & 1]
       set FPIO.B4 [expr ($FPIO >> 4) & 1]
       set FPIO.B5 [expr ($FPIO >> 5) & 1]
       set FPIO.B6 [expr ($FPIO >> 6) & 3]
       set FPIO.B14 [expr ($FPIO >> 14) & 1]       
       set FPIO.B15 [expr ($FPIO >> 15) & 1]
    }

   proc do_SetFPIO {} {
      variable FPIO 
      variable FPIO.B15 
      variable FPIO.B14 
      variable FPIO.B6 
      variable FPIO.B5 
      variable FPIO.B4 
      variable FPIO.B3 
      variable FPIO.B2 
      variable FPIO.B1 
      variable FPIO.B0

      set FPIO [expr ([set FPIO.B15] << 15) | \
                     ([set FPIO.B14] << 14) | \
                     ([set FPIO.B6] << 6) | \
                     ([set FPIO.B5] << 5) | \
                     ([set FPIO.B4] << 4) | \
                     ([set FPIO.B3] << 3) | \
                     ([set FPIO.B2] << 2) | \
                     ([set FPIO.B1] << 1) | \
                     ([set FPIO.B0])]

     WriteRegister FPIOControl $FPIO
   }

    proc do_SetChannelRegister {w i v} {
        variable allchans
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "$w.$i = $v"}

        switch -glob $w {
            POSTTRG   {if {$allchans} {WriteRegister ChPostTrig $v} else {WriteRegister ChPostTrig$i $v}}
            DAC       {if {$allchans} {WriteRegister ChDAC $v}      else {WriteRegister ChDAC$i $v}}
            DPP_PAR1  {if {$allchans} {WriteRegister ChDPP_PAR1 $v} else {WriteRegister ChDPP_PAR1$i $v}}
            DPP_PAR2  {if {$allchans} {WriteRegister ChDPP_PAR2 $v} else {WriteRegister ChDPP_PAR2$i $v}}
            DPP_PAR3  {if {$allchans} {WriteRegister ChDPP_PAR3 $v} else {WriteRegister ChDPP_PAR3$i $v}}
            DPP_PAR4  {if {$allchans} {WriteRegister ChDPP_PAR4 $v} else {WriteRegister ChDPP_PAR4$i $v}}
            default {}
        }
   }

    proc do_UpdateChannelRegisters {} {

       for {set i 0} {$i < 8} {incr i} {
           variable DAC.Value$i ; set DAC.Value$i [ReadRegister ChDAC$i]
           variable POSTTRG.Value$i ; set POSTTRG.Value$i [expr 8191 & [ReadRegister ChPostTrig$i]]
           variable OCCUPANCY.Value$i ; set OCCUPANCY.Value$i [ReadRegister ChBufs$i]

           variable STATUS.BufferFreeErr$i
           variable STATUS.CHn+1Enabled$i
           variable STATUS.CHnEnabled$i
           variable STATUS.DACBusy$i
           variable STATUS.MemEmpty$i
           variable STATUS.MemFull$i

           set STATUS [ReadRegister ChStatus$i]
           
           set STATUS.BufferFreeErr$i [expr ($STATUS >> 5) & 1]
           set STATUS.CHn+1Enabled$i [expr ($STATUS >> 4) & 1]
           set STATUS.CHnEnabled$i [expr ($STATUS >> 3) & 1]
           set STATUS.DACBusy$i [expr ($STATUS >> 2) & 1]
           set STATUS.MemEmpty$i [expr ($STATUS >> 1) & 1]
           set STATUS.MemFull$i [expr $STATUS & 1]

           variable DPP_PAR1.Value$i
           variable DPP_PAR1.RiseTime$i
           variable DPP_PAR1.AveragingWindow$i
           variable DPP_PAR1.DecayTime$i

           set PAR1 [ReadRegister ChDPP_PAR1$i]

           set DPP_PAR1.Value$i $PAR1
           set DPP_PAR1.RiseTime$i [expr $PAR1 & 0xff]
           set DPP_PAR1.AveragingWindow$i [expr ($PAR1 >> 8) & 0x3f]
           set DPP_PAR1.DecayTime$i [expr ($PAR1 >> 16) & 0x0000ffff]

           variable DPP_PAR2.Value$i
           variable DPP_PAR2.TrapezoidRiseTime$i
           variable DPP_PAR2.TrapezoidFlatTop$i
           variable DPP_PAR2.PeakValue2Divider$i
           variable DPP_PAR2.BaseLineMean$i

           set PAR2 [ReadRegister ChDPP_PAR2$i]

           set DPP_PAR2.Value$i $PAR2
           set DPP_PAR2.TrapezoidRiseTime$i [expr $PAR2 & 0x3ff]
           set DPP_PAR2.TrapezoidFlatTop$i [expr ($PAR2 >> 12) & 0x3ff]
           set DPP_PAR2.PeakValue2Divider$i [expr ($PAR2 >> 24) & 0x3f]
           set DPP_PAR2.BaseLineMean$i [expr ($PAR2 >> 30) & 0x3]

           variable DPP_PAR3.Value$i
           variable DPP_PAR3.Threshold$i
           variable DPP_PAR3.Decimation$i
           variable DPP_PAR3.FlatTopDelay$i
           variable DPP_PAR3.PeakAvWindow$i
           variable DPP_PAR3.DigitalGain$i

           set PAR3 [ReadRegister ChDPP_PAR3$i]

           set DPP_PAR3.Value$i $PAR3
           set DPP_PAR3.Threshold$i [expr $PAR3 & 0x3fff]
           set DPP_PAR3.Decimation$i [expr ($PAR3 >> 14) & 0x3]
           set DPP_PAR3.FlatTopDelay$i [expr ($PAR3 >> 16) & 0x7ff]
           set DPP_PAR3.PeakAvWindow$i [expr ($PAR3 >> 28) & 0x3]
           set DPP_PAR3.DigitalGain$i [expr ($PAR3 >> 30) & 0x3]

           variable DPP_PAR4.Value$i
           variable DPP_PAR4.TrigWinWidth$i
           variable DPP_PAR4.TrigWinOffset$i

           set PAR4 [ReadRegister ChDPP_PAR4$i]

           set DPP_PAR4.Value$i $PAR4
           set DPP_PAR4.TrigWinOffset$i [expr $PAR4 & 0x1ff]
           set DPP_PAR4.TrigWinWidth$i [expr (($PAR4 >> 9) & 0x7) * 16]
       }
 
   }

   proc do_SetDPPparameter {w s vl} {
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "SetDPPparameter $w $s $vl"}

       switch $w {

           DPP_PAR1 {
               set Ch [expr $s & 7]
               variable DPP_PAR1.RiseTime$Ch
               variable DPP_PAR1.AveragingWindow$Ch
               variable DPP_PAR1.DecayTime$Ch
               set id [expr $s >> 3]
               if {$id == 0} {set DPP_PAR1.RiseTime$Ch $vl}
               if {$id == 1} {set DPP_PAR1.AveragingWindow$Ch $vl}
               if {$id == 2} {set DPP_PAR1.DecayTime$Ch $vl}
               set Reg [expr [set DPP_PAR1.RiseTime$Ch] | \
                           ([set DPP_PAR1.AveragingWindow$Ch] << 8) | \
                           ([set DPP_PAR1.DecayTime$Ch] << 16)]
           }
           DPP_PAR2 {
               set Ch [expr $s & 7]
               variable DPP_PAR2.TrapezoidRiseTime$Ch
               variable DPP_PAR2.TrapezoidFlatTop$Ch
               variable DPP_PAR2.PeakValue2Divider$Ch
               variable DPP_PAR2.BaseLineMean$Ch
               set id [expr $s >> 3]
               if {$id == 0} {set DPP_PAR2.TrapezoidRiseTime$Ch $vl}
               if {$id == 1} {set DPP_PAR2.TrapezoidFlatTop$Ch $vl}
               if {$id == 2} {set DPP_PAR2.PeakValue2Divider$Ch $vl}
               set Reg [expr [set DPP_PAR2.TrapezoidRiseTime$Ch] | \
                           ([set DPP_PAR2.TrapezoidFlatTop$Ch] << 12) | \
                           ([set DPP_PAR2.PeakValue2Divider$Ch] << 24)| \
                           ([set DPP_PAR2.BaseLineMean$Ch] << 30)]
           }
           DPP_PAR3 {
               set Ch [expr $s & 7]
               variable DPP_PAR3.Threshold$Ch
               variable DPP_PAR3.Decimation$Ch
               variable DPP_PAR3.FlatTopDelay$Ch
               variable DPP_PAR3.PeakAvWindow$Ch
               variable DPP_PAR3.DigitalGain$Ch
               set id [expr $s >> 3]
               if {$id == 0} {set DPP_PAR3.Threshold$Ch $vl}
               if {$id == 1} {set DPP_PAR3.FlatTopDelay$Ch $vl}               
               set Reg [expr [set DPP_PAR3.Threshold$Ch] | \
                           ([set DPP_PAR3.Decimation$Ch] << 14) | \
                           ([set DPP_PAR3.FlatTopDelay$Ch] << 16)| \
                           ([set DPP_PAR3.PeakAvWindow$Ch] << 28) | \
                           ([set DPP_PAR3.DigitalGain$Ch] << 30)]
           }
           DPP_PAR4 {
               set Ch [expr $s & 7]
               variable DPP_PAR4.TrigWinWidth$Ch
               variable DPP_PAR4.TrigWinOffset$Ch
               set id [expr $s >> 3]
               if {$id == 0} {set DPP_PAR4.TrigWinWidth$Ch $vl}
               if {$id == 1} {set DPP_PAR4.TrigWinOffset$Ch $vl}         
               set Reg [expr [set DPP_PAR4.TrigWinOffset$Ch] | \
                           (([set DPP_PAR4.TrigWinWidth$Ch]/16) << 9)]
           }
       }

       do_SetChannelRegister $w $Ch $Reg
   }
 
    proc do_Save {} {
        variable ::VMEConfig::ConfigBase
        variable ModuleIndex
        variable ModuleMenu
        variable ModuleName

        variable CONFIGURATION
        variable BUFF_ORG
        variable POST_TRG
        variable CUST_SIZE 
        variable CHENABLE 
        variable TRIGSRCENABLE 
        variable FPTRIGENABLE 
        variable ANALOGMON 
        variable FPIO

        for {set i 0} {$i < 8} {incr i} {
            variable DAC.Value$i
            variable POSTTRG.Value$i
            variable DPP_PAR1.Value$i
            variable DPP_PAR2.Value$i
            variable DPP_PAR3.Value$i
            variable DPP_PAR4.Value$i
        }

        set SaveFile [file join $ConfigBase [set ModuleName].dat]

        set z [catch {open $SaveFile w} file]
        if {$z != 0} {
            Alert "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set SAV $ModuleIndex
        foreach module $ModuleMenu {
           do_Select $module   ;# will cause reload of module parameters
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set module]"

           puts $file "[set ModuleName]#[set module].ChEnable      [set CHENABLE]"
           puts $file "[set ModuleName]#[set module].ChConfig      [set CONFIGURATION]"
           puts $file "[set ModuleName]#[set module].BufferOrg     [set BUFF_ORG]"
           puts $file "[set ModuleName]#[set module].TrigSrcEnable [set TRIGSRCENABLE]"
           puts $file "[set ModuleName]#[set module].FpTrigOutEnable  [set FPTRIGENABLE]"
           puts $file "[set ModuleName]#[set module].FPIOControl   [set FPIO]"
           puts $file "[set ModuleName]#[set module].CustomSize    [set CUST_SIZE]"
           puts $file "[set ModuleName]#[set module].AnalogMon     [set ANALOGMON]"

           for {set i 0} {$i < 8} {incr i} {
              puts $file "[set ModuleName]#[set module].ChDAC$i [set DAC.Value$i]"
              puts $file "[set ModuleName]#[set module].ChPostTrig$i [set POSTTRG.Value$i]"
              puts $file "[set ModuleName]#[set module].ChDPP_PAR1$i [set DPP_PAR1.Value$i]"
              puts $file "[set ModuleName]#[set module].ChDPP_PAR2$i [set DPP_PAR2.Value$i]"
              puts $file "[set ModuleName]#[set module].ChDPP_PAR3$i [set DPP_PAR3.Value$i]"
              puts $file "[set ModuleName]#[set module].ChDPP_PAR4$i [set DPP_PAR4.Value$i]"
           }
        }

        do_Select $SAV

        close $file

        InsertLog "Settings for CAEN [set ModuleName] modules updated in $SaveFile"

        Elog INFORMATION "Settings for CAEN [set ModuleName] modules updated in $SaveFile"
    }

    proc do_Restore {} {
        variable ::VMEConfig::ConfigBase
        variable ModuleIndex
        variable ModuleName
        variable allmodules
        variable allchannels

        InsertLog "Restoring Settings for CAEN [set ModuleName] modules"

        set SaveFile [file join $ConfigBase [set ModuleName].dat]

        set z [catch {open $SaveFile r} file]
        if {$z != 0} {
            Alert "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set allmodules 0
        set allchannels 0

        set SAV $ModuleIndex

        WriteRegister Reset 0   ;# software reset

        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            if {[string compare -length 6 $item v1724#] != 0} {continue}
            set m [string range $item 6 6]
            if {$m != $ModuleIndex} {do_Select $m}
            set p [second [split [first $item] .]]
            set vl [second $item]
            WriteRegister $p $vl
        }
        do_Select $SAV

        close $file

        InsertLog "Settings for CAEN [set ModuleName] modules restored from $SaveFile"

        Elog INFORMATION "Settings for CAEN [set ModuleName] modules restored from $SaveFile"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {;#UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLCHANS   {variable allchans; set allchans [expr ($allchans + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   MREGISTER     {do_SelectModuleRegister [string range $w 10 end]}
                   MREGISTERHELP  {do_RegisterHelp M}

                   CHREGISTER    {do_SelectChannelRegister [string range $w 11 end]}
                   CHREGISTERHELP  {do_RegisterHelp Ch}

                   MSETTINGS      {
                       do_SetModuleRegister [lindex $cgidata 3] [lindex $cgidata 5]
                    ;#   do_UpdateModuleRegisters
                   }

                   MSETTING      {
                       do_SetModuleRegister [lindex $w 1] [lindex $w 2]
                    ;#   do_UpdateModuleRegisters
                   }

                   ACTION {
                        switch [lindex $w 1] {
                           AcqStart {
                              WriteRegister BLTEventNum 1
                              WriteRegister Control 16
                              WriteRegister Clear 0
                              WriteRegister SoftwareSyncReset 0
                              ReadRegister ChFPGARev0
                              ReadRegister FirmWareLicense
                              after 10
                              ReadRegister FirmWareLicense
                              WriteRegister AcqControl 4
                           }
                           default {}
                        }
                   }
 
                   DAC -
                   POSTTRG -
                   CHSETTING  {
                       do_SetChannelRegister [lindex $w 0] [lindex $w 1] [lindex $w 2]
                     ;#  do_UpdateChannelRegisters
                   }

                   DPPSETTING  {
                       set Reg [lindex $w 1]
                       set Ch [lindex $w 2]
                       variable $Reg$Ch
                       set $Reg$Ch [lindex $w 3]
                       do_SetDPPparameter [first [split $Reg .]] [expr $Ch + 0xf0] -1
                     ;#  do_UpdateChannelRegisters
                   }

                   DPP_PAR1 -
                   DPP_PAR2 -
                   DPP_PAR3 -
                   DPP_PAR4 {
                       do_SetDPPparameter [lindex $w 0] [lindex $w 1] [lindex $w 2]
                     ;#  do_UpdateChannelRegisters
                   }

                   SAVE      {do_Save}
                   RESTORE   {do_Restore}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

